/***************************************************************************
        actionhandler.cpp  -  action handler for pages/system object
                             -------------------
    begin                : Fri Apr 16 2004
    copyright            : (C) 2004 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "actionhandler.h"
 
using namespace std;

ActionHandler::ActionHandler(ScriptBase *script, std::string actionname, bool system) {
  this->script = script;
  script->IncRef();
  this->actionname = actionname;
  this->system = system;
}

ActionHandler::~ActionHandler(void) {
  script->DecRef();
}

void ActionHandler::Execute(void) {
  script->Run();
}

std::string ActionHandler::GetAction(void) {
  return actionname;
}

bool ActionHandler::IsSystem(void) {
  return system;
}
