/***************************************************************************
                          actionmanager.h  -  action manager header
                             -------------------
    begin                : Sun Dec 22 2002
    copyright            : (C) 2002 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__ACTIONMANAGER_H
#define INCLUDED__ACTIONMANAGER_H
 
#include <vector>
#include <string>

#include "actionobject.h"

// Internal struct used by
struct actionhandler {
  std::string actionname;
  ActionObject *aobject;
};

// Main action manager object
class ActionManager {
  public:
    ActionManager(void);
    virtual ~ActionManager(void);
    int RegisterLocalAction(std::string actionname, ActionObject *aobject);
    int RegisterGlobalAction(std::string actionname, ActionObject *aobject);
    void UnregisterLocalAction(std::string actionname, ActionObject *aobject);
    void UnregisterGlobalAction(std::string actionname, ActionObject *aobject);
    void UnregisterObjectActions(ActionObject *aobject);
    int ExecuteAction(std::string action);
  private:
    std::vector<actionhandler *> globalhandlers;
    std::vector<actionhandler *> localhandlers;
};

// Function prototypes

std::string GetUserAction(std::string actionname);

#endif
