/***************************************************************************
                attributelist.cpp  -  list of name/value pairs
                             -------------------
    begin                : Thu Jul 17 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "attributelist.h"
 
using namespace std;

AttributeList::AttributeList(void) {
  
}

AttributeList::~AttributeList(void) {
  // Clear out internal vector
  while(attrs.size() > 0)
    attrs.pop_back();
}

void AttributeList::AddAttribute(string name, Variant defaultvalue) {
  AttributeElement attr;
  attr.name = name;
  attr.value = defaultvalue;
  attrs.push_back(attr);
}

AttributeElement *AttributeList::FindAttribute(string name) {
  for(unsigned int i=0;i<attrs.size();i++) {
    if(attrs[i].name == name)
      return &attrs[i];
  }
  return NULL;
}

Variant AttributeList::GetAttributeValue(string name) {
  AttributeElement *attr = FindAttribute(name);
  if(attr)
    return attr->value;

  return VARNULL; // FIXME: Danger Will Robinson! how do we know if the value doesn't exist?!
}

int AttributeList::GetAttributeType(string name) {
  AttributeElement *attr = FindAttribute(name);
  if(attr)
    return attr->value.GetType();
    
  return -1;
}

void AttributeList::SetAttributeValue(string name, Variant value) {
  AttributeElement *attr = FindAttribute(name);
  if(attr)
    attr->value = value;
}

int AttributeList::size(void) {
  return attrs.size();
}
