/***************************************************************************
                attributelist.h  -  list of name/value pairs
                             -------------------
    begin                : Thu Jul 17 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__ATTRIBUTELIST_H
#define INCLUDED__ATTRIBUTELIST_H

#include <string>
#include <vector>

#include "variant.h"

struct AttributeElement {
  std::string name;
  Variant value;
};

class AttributeList {
  private:
    std::vector<AttributeElement> attrs;
    AttributeElement *FindAttribute(std::string name);
  public:
    AttributeList(void);
    virtual ~AttributeList(void);
    void AddAttribute(std::string name, Variant defaultvalue);
    Variant GetAttributeValue(std::string name);
    int GetAttributeType(std::string name);
    void SetAttributeValue(std::string name, Variant value);
    int size(void);
};

#endif
