/***************************************************************************
                          customobject.h  -  eboxy custom object
                             -------------------
    begin                : Thu May 22 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__CUSTOMOBJECT_H
#define INCLUDED__CUSTOMOBJECT_H
 
#include "dynamicobject.h"
#include "customproperty.h"
#include "methodhandler.h"
#include "variant.h"
 
class CustomObject: public virtual DynamicObject {
  public:
    CustomObject(void);
    virtual ~CustomObject(void);
    int AddProperty(const char *name, propertygetfn getter, propertysetfn setter);
    int AddProperty(CustomProperty *prop);
    int AddMethod(MethodHandler *mh);
    virtual Variant GetPropertyValue(const char *property);
    virtual int SetPropertyValue(const char *property, Variant value);
    virtual bool HasProperty(const char *property);
    CustomProperty *GetProperty(int index);
    const char *GetDefaultProperty(void);
    int GetPropertyCount(void);
    CustomProperty *FindProperty(const char *name);
    int FireEvent(const char *event);
    int FireEventWait(const char *event);
  protected:
    CustomProperty *defaultproperty;
    bool CheckMember(const char *name);

    Variant pget_Name(void);
    Variant pget_Type(void);
    Variant pget_PropertyCount(void);
    Variant pget_MethodCount(void);
    Variant pget_EventCount(void);

    Variant m_GetProperty(int numargs, Variant args[]);
    Variant m_GetMethod(int numargs, Variant args[]);
    Variant m_GetEvent(int numargs, Variant args[]);
  private:
    vector<CustomProperty *> properties;
};

#endif
