/***************************************************************************
                          customproperty.h  -  property base class
                             -------------------
    begin                : Thu May 22 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__CUSTOMPROPERTY_H
#define INCLUDED__CUSTOMPROPERTY_H

#include "variant.h"

class CustomProperty {
  public:
    CustomProperty(const char *name);
    virtual ~CustomProperty(void);
    const char *GetName(void);
    virtual int SetValue(Variant value) = 0;
    virtual Variant GetValue(void) = 0;
    virtual bool IsRequired(void);
    virtual void SetRequired(bool required);
    virtual bool IsReadOnly(void);
  protected:
    char *name;
    bool required;
};

#endif
