/***************************************************************************
                          eventhandler.h  -  eboxy event handler
                             -------------------
    begin                : Thu May 22 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__EVENTHANDLER_H
#define INCLUDED__EVENTHANDLER_H

#include <pthread.h>
   
#include "object.h"

class EventHandler {
  public:
    EventHandler(const char *name, Object *source, Object *sink);
    virtual ~EventHandler(void);
    const char *GetName(void);
    int Fire(bool allowthread);
    Object *GetSource(void);
    Object *GetSink(void);
    void SetThreaded(bool threaded);
    bool IsThreaded(void);
  protected:
    virtual int InternalFire(void);
    char *name;
    Object *source;         // the object that fires the events - FIXME: should be ebDynamicObject, forward reference
    Object *sink;           // the object that registered the event handler (and recieves the events)
    bool threaded;
    pthread_t event_thread;
};

#endif
