/***************************************************************************
  functionproperty.cpp  -  property object that uses getter/setter functions
                             -------------------
    begin                : Sun Sep 8 2002
    copyright            : (C) 2002 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <iostream>
#include <cstring>
#include <cstdlib>

#include "functionproperty.h"

using namespace std;

FunctionProperty::FunctionProperty(const char *name, propertygetfn getter, propertysetfn setter)
: CustomProperty(name) {
  this->getter = getter;
  this->setter = setter;
}

int FunctionProperty::SetValue(Variant value) {
  if(setter) {
    string str = value;
    return setter(name, str.c_str());
  }
  else {
    cerr << "Property " << name << " is read-only" << endl;
    return -1;
  }
}

Variant FunctionProperty::GetValue(void) {
  Variant retvar;
  char *retstr;

  if(getter) {
    retstr = getter(name);
    if(retstr) {
      retvar = anytovariant(retstr);
      free(retstr);
    }
    else
      retvar = VARNULL;
    return retvar;
  }
  else {
    cerr << "Property " << name << " is write-only" << endl;
    return VARNULL;
  }
}
