/***************************************************************************
          interfaceevent.h  -  header for interface event definitions
                             -------------------
    begin                : Sun Nov 23 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__INTERFACEEVENT_H
#define INCLUDED__INTERFACEEVENT_H

enum eboxykey {
  EKEY_NONE, // ie, invalid key
  EKEY_a,
  EKEY_b,
  EKEY_c,
  EKEY_d,
  EKEY_e,
  EKEY_f,
  EKEY_g,
  EKEY_h,
  EKEY_i,
  EKEY_j,
  EKEY_k,
  EKEY_l,
  EKEY_m,
  EKEY_n,
  EKEY_o,
  EKEY_p,
  EKEY_q,
  EKEY_r,
  EKEY_s,
  EKEY_t,
  EKEY_u,
  EKEY_v,
  EKEY_w,
  EKEY_x,
  EKEY_y,
  EKEY_z,
  EKEY_0,
  EKEY_1,
  EKEY_2,
  EKEY_3,
  EKEY_4,
  EKEY_5,
  EKEY_6,
  EKEY_7,
  EKEY_8,
  EKEY_9,

  EKEY_BACKSPACE,
  EKEY_TAB,
  EKEY_RETURN,
  EKEY_PAUSE,
  EKEY_ESCAPE,
  EKEY_SPACE,

  EKEY_QUOTE,
  EKEY_COMMA,
  EKEY_MINUS,
  EKEY_DOT,
  EKEY_SLASH,
  EKEY_SEMICOLON,
  EKEY_EQUALS,
  EKEY_LEFTBRACKET,
  EKEY_BACKSLASH,
  EKEY_RIGHTBRACKET,
  EKEY_BACKQUOTE,

  EKEY_F1,
  EKEY_F2,
  EKEY_F3,
  EKEY_F4,
  EKEY_F5,
  EKEY_F6,
  EKEY_F7,
  EKEY_F8,
  EKEY_F9,
  EKEY_F10,
  EKEY_F11,
  EKEY_F12,
  EKEY_F13,
  EKEY_F14,
  EKEY_F15,

  EKEY_KP0,
  EKEY_KP1,
  EKEY_KP2,
  EKEY_KP3,
  EKEY_KP4,
  EKEY_KP5,
  EKEY_KP6,
  EKEY_KP7,
  EKEY_KP8,
  EKEY_KP9,
  EKEY_KPSTAR,
  EKEY_KPSLASH,
  EKEY_KPDOT,
  EKEY_KPMINUS,
  EKEY_KPPLUS,
  EKEY_KPENTER,
  EKEY_KPEQUALS,
  EKEY_UP,
  EKEY_DOWN,
  EKEY_RIGHT,
  EKEY_LEFT,
  EKEY_DELETE,
  EKEY_INSERT,
  EKEY_HOME,
  EKEY_END,
  EKEY_PAGEUP,
  EKEY_PAGEDOWN,

  EKEY_LSHIFT,
  EKEY_RSHIFT,
  EKEY_LALT,
  EKEY_RALT,
  EKEY_LCTRL,
  EKEY_RCTRL,
  EKEY_LSUPER,
  EKEY_RSUPER,
  EKEY_MENU,
  EKEY_PRINTSCREEN,

  EKEY_NUMLOCK,
  EKEY_CAPSLOCK,
  EKEY_SCROLLLOCK,

  // Unused
  EKEY_RMETA,
  EKEY_LMETA,
  EKEY_MODE,
  EKEY_HELP,
  EKEY_SYSREQ,
  EKEY_BREAK,
  EKEY_POWER,
  EKEY_CLEAR,
  EKEY_EXCLAIM,
  EKEY_QUOTEDBL,
  EKEY_HASH,
  EKEY_DOLLAR,
  EKEY_AMPERSAND,
  EKEY_LEFTPAREN,
  EKEY_RIGHTPAREN,
  EKEY_ASTERISK,
  EKEY_PLUS,
  EKEY_LESS,
  EKEY_GREATER,
  EKEY_QUESTION,
  EKEY_AT,
  EKEY_CARET,
  EKEY_UNDERSCORE,
  EKEY_JOY_BUTTON_1,
  EKEY_JOY_BUTTON_2,
  EKEY_JOY_BUTTON_3,
  EKEY_JOY_BUTTON_4,
  EKEY_JOY_BUTTON_5,
  EKEY_JOY_BUTTON_6,
  EKEY_JOY_BUTTON_7,
  EKEY_JOY_BUTTON_8,
  EKEY_JOY_BUTTON_9,
  EKEY_JOY_UP,
  EKEY_JOY_DOWN,
  EKEY_JOY_LEFT,
  EKEY_JOY_RIGHT,
  EKEY_JOY_HAT_UP,
  EKEY_JOY_HAT_DOWN,
  EKEY_JOY_HAT_LEFT,
  EKEY_JOY_HAT_RIGHT,
  EKEY_JOY_BALL_UP,
  EKEY_JOY_BALL_DOWN,
  EKEY_JOY_BALL_LEFT,
  EKEY_JOY_BALL_RIGHT
};

// Modifier types
enum {
  MODKEY_NONE     = 0x0,    // strictly no modifier keys pressed
  MODKEY_LSHIFT   = 0x1,    // left shift
  MODKEY_RSHIFT   = 0x2,    // right shift
  MODKEY_SHIFTMASK = MODKEY_LSHIFT | MODKEY_RSHIFT,  // both left & right shift
  MODKEY_SHIFT    = 0x4,    // either shift
  MODKEY_LCTRL    = 0x8,    // etc...
  MODKEY_RCTRL    = 0x10,
  MODKEY_CTRLMASK = MODKEY_LCTRL | MODKEY_RCTRL,
  MODKEY_CTRL     = 0x20,
  MODKEY_LALT     = 0x40,
  MODKEY_RALT     = 0x80,
  MODKEY_ALTMASK  = MODKEY_LALT | MODKEY_RALT,
  MODKEY_ALT      = 0x100,

  // FIXME: Lock keys are ignored right now (difficult to handle)
  MODKEY_NUMLOCK  = 0x1000,
  MODKEY_CAPSLOCK = 0x2000,
  MODKEY_LOCKMASK = MODKEY_NUMLOCK | MODKEY_CAPSLOCK,

  MODKEY_ANYLOCK  = 0x100000,   // don't care about lock status but do care about other modifiers
  MODKEY_ANY      = 0x200000    // don't care what modifiers are pressed
};

enum inputeventtype {
  EIT_KEYDOWN,
  EIT_KEYUP,
  EIT_JOYBUTTONDOWN,
  EIT_JOYBUTTONUP,
  EIT_JOYAXISMOTION,
  EIT_JOYHATMOTION
};

struct InterfaceEvent {
  inputeventtype type;
  eboxykey key;
  int keymod;
};

#endif
