/***************************************************************************
           interfaceplugin.h  -  base class for interface plugins
                             -------------------
    begin                : Sun Jul 13 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__INTERFACEPLUGIN_H
#define INCLUDED__INTERFACEPLUGIN_H
 
#include <string>
#include <vector>

#include "attributelist.h"
#include "object.h"
#include "resourcemanagerbase.h"
#include "pagebase.h"
#include "interfaceevent.h"

class InterfacePlugin: public AttributeList {
  private:
  public:
    InterfacePlugin(void);
    virtual ~InterfacePlugin(void);
    virtual int Initialise(void) = 0;
    virtual void BeginEventLoop(void (*loopfunc)(void), bool(*interfaceeventfunc)(InterfaceEvent&)) = 0;
    virtual void Quit(void) = 0;
    virtual void Uninitialise(void) = 0;
    virtual void ClearPages(bool clearall) = 0;
    virtual Object *CreateObject(const char *type, const char *name) = 0;
    virtual void DeleteObject(Object *object) = 0;
    virtual int SwitchPage(PageBase *page) = 0;
    virtual ResourceManagerBase *GetResourceManager(void) = 0;
    virtual PageBase *GetCurrentPage(void) = 0;
    virtual PageBase *GetLoadedPage(void) = 0;
    virtual PageBase *FindPage(const char *name) = 0;
    virtual int GetPageCount(void) = 0;
    virtual PageBase *GetPage(unsigned int index) = 0;
    virtual DynamicObject *FindExtPageObject(const char *name) = 0;
    virtual bool HasFocus(void) = 0;
    virtual int GetScreenWidth(void) = 0;
    virtual int GetScreenHeight(void) = 0;
};

#endif
