/***************************************************************************
               labelwidgetbase.h  -  base class for label widgets
                             -------------------
    begin                : Sat Nov 15 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__LABELWIDGETBASE_H
#define INCLUDED__LABELWIDGETBASE_H

#include <string>

#include "resource.h"
#include "widgetbase.h"
#include "variant.h"

enum enum_textalign {
  TEXTALIGN_LEFT,
  TEXTALIGN_CENTER,
  TEXTALIGN_RIGHT
};

class LabelWidgetBase: public virtual WidgetBase {
  public:
    LabelWidgetBase(const char *name, int x, int y, int w, int h, std::string text, FontResource *font);
    virtual ~LabelWidgetBase(void);
    virtual void SetText(std::string text);
    virtual std::string GetText(void);
    virtual void SetFont(FontResource *font);
    virtual void SetFontColor(eboxy_color c);
    virtual void SetAutoSize(bool autosize);
    virtual void SetAlign(enum_textalign textalign);
    virtual void SetWordWrap(bool wordwrap);
  protected:
    std::string text;
    FontResource *font;
    int fontsize;
    eboxy_color fontcolor;
    enum_textalign textalign;
    bool wordwrap;
    bool autosize;

    Variant pget_Caption(void);
    int pset_Caption(Variant value);
    Variant pget_Font(void);
    int pset_Font(Variant value);
    Variant pget_FontSize(void);
    int pset_FontSize(Variant value);
    Variant pget_FontColor(void);
    int pset_FontColor(Variant value);
    Variant pget_TextAlign(void);
    int pset_TextAlign(Variant value);
    Variant pget_AutoSize(void);
    int pset_AutoSize(Variant value);
    Variant pget_WordWrap(void);
    int pset_WordWrap(Variant value);
};

enum_textalign textalignstrtoint(const string &str);
string textaligninttostr(int textalign);

#endif
