/***************************************************************************
          membermethodhandler.h  -  method handler that uses templates to
                                    access member functions
                             -------------------
    begin                : Mon Nov 10 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__MEMBERMETHODHANDLER_H
#define INCLUDED__MEMBERMETHODHANDLER_H

#include "methodhandler.h"
#include "variant.h"

template <class T> class MemberMethodHandler: public MethodHandler {
  typedef Variant handler(int numargs, Variant args[]);
  typedef handler (T::*cmethod);

  public:
    // I tried to put the code in another .cpp file, but it turns out to be easier just to put it in
    // the header, as otherwise I had problems getting the template to instantiate.

    MemberMethodHandler<T>(const char *name, T *owner, int numargs, cmethod m)
    : MethodHandler(name, dynamic_cast<Object *>(owner), numargs) {
      this->f = m;
      this->obj = owner;
    }
    Variant Call(int numargs, Variant args[]) {
      if(numargs == this->numargs)
        return (obj->*f)(numargs, args);
      else {
        cerr << "Wrong number of arguments passed to method " << name << " of object " << owner->GetName();
        cerr << " (" << this->numargs << " expected, " << numargs <<  " supplied)" << endl;
        return VARNULL;
      }
    }

  protected:
    T *obj;
    cmethod f;
};


#endif
