/***************************************************************************
                 methodhandler.h - method handling base object
                             -------------------
    begin                : Thu May 22 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__METHODHANDLER_H
#define INCLUDED__METHODHANDLER_H

#include "object.h"
#include "variant.h"

class MethodHandler {
  public:
    MethodHandler(const char *name, Object *owner, int numargs);
    virtual ~MethodHandler(void);
    const char *GetName(void);
    Object *GetOwner(void);
    virtual Variant Call(int numargs, Variant args[]) = 0;
  protected:
    char *name;
    Object *owner;
    int numargs;
};

#endif
