/***************************************************************************
      notifyobject.h  -  abstract base class for callback notification
                             -------------------
    begin                : Thu May 22 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__NOTIFY_H
#define INCLUDED__NOTIFY_H

#include "object.h"
 
// Abstract base class for objects which wish to be notified when something happens to an object
// (used by DynamicObject to tell an ObjectContainer that it is going to be freed)
class NotifyObject {
  public:
    virtual void Notify(Object *obj) = 0;
};

#endif
