/***************************************************************************
         picturewidgetbase.h  -  base class for static picture widget
                             -------------------
    begin                : Mon Nov 17 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__PICTUREWIDGETBASE_H
#define INCLUDED__PICTUREWIDGETBASE_H

#include "widgetbase.h"
#include "resource.h"
#include "variant.h"

class PictureWidgetBase: public virtual WidgetBase {
  public:
    PictureWidgetBase(const char *name, int x, int y, ImageResource *image);
    virtual void SetImage(ImageResource *image) = 0;
    virtual void ReloadImage(void);
  protected:
    ImageResource *image;

    Variant pget_Image(void);
    int pset_Image(Variant value);

    Variant m_ReloadImage(int numargs, Variant args[]);
};

#endif
