/***************************************************************************
                          resource.h  -  resource classes
                             -------------------
    begin                : Mon Oct 6 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__RESOURCE_H
#define INCLUDED__RESOURCE_H

#include <string>

class Resource {
  public:
    Resource(const std::string filename);
    virtual ~Resource(void);
    const std::string GetFilename(void);
    void *GetHandle(void);
    virtual void *Load(void) = 0;
    virtual void Unload(void) = 0;
  protected:
    std::string filename;
    void *reshandle;
};

typedef Resource ImageResource;

class FontResource: public Resource {
  public:
    FontResource(std::string name, int fontsize);
    int GetFontSize(void);
  protected:
    int fontsize;
};

#endif
