/***************************************************************************
         resourcemanagerbase.h  -  base class for resource managers
                             -------------------
    begin                : Thu Jul 10 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__RESOURCEMANAGERBASE_H
#define INCLUDED__RESOURCEMANAGERBASE_H

#include <vector>
#include <string>

#include "resource.h"

class ResourceManagerBase {
  public:
    ResourceManagerBase(void);
    virtual ~ResourceManagerBase(void);
    ImageResource *LoadImageResource(std::string filename, bool force);
    FontResource *LoadFontResource(std::string filename, int fontsize);
    virtual void UnloadAllResources(void) = 0;
    void SetImageSearchPath(std::string path);
    void SetFontSearchPath(std::string path);
  protected:
    std::string imagepath;
    std::string fontpath;

    virtual ImageResource *InternalLoadImageResource(std::string filename, bool force) = 0;
    virtual FontResource *InternalLoadFontResource(std::string filename, int fontsize) = 0;
    std::string SearchPath(std::string &path, std::string &filename);
};

#endif
