/***************************************************************************
                scriptbase.cpp  -  base class for script objects
                             -------------------
    begin                : Mon Oct 6 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <cstdlib>
#include <cstring>

#include <iostream> // FIXME

#include "scriptbase.h"

using namespace std;

ScriptBase::ScriptBase(const char *name, const char *code)
: Object(name) {
  this->code = strdup(code);
  this->lineoffset = 0;
  this->refcount = 1;
}

ScriptBase::~ScriptBase(void) {
  free(code);
}

void ScriptBase::SetLineOffset(int line) {
  this->lineoffset = line;
}

void ScriptBase::IncRef(void) {
  refcount++;
}

bool ScriptBase::DecRef(void) {
  refcount--;
  if(refcount==0) {
    delete this;
    return true;
  }
  else
    return false;
}
