/***************************************************************************
         scripteventhandler.cpp  -  event handler which runs a script
                             -------------------
    begin                : Sat Sep 21 2002
    copyright            : (C) 2002 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "scripteventhandler.h"

using namespace std;

ScriptEventHandler::ScriptEventHandler(const char *name, Object *source, Object *sink, ScriptBase *eventscript)
: EventHandler(name, source, sink) {
  this->eventscript = eventscript;
  eventscript->IncRef();
}

ScriptEventHandler::~ScriptEventHandler(void) {
  eventscript->DecRef();
}

int ScriptEventHandler::InternalFire(void) {
  return eventscript->Run();
}
