/***************************************************************************
          scrollbarwidgetbase.h  -  base class for scrollbar widgets
                             -------------------
    begin                : Mon Nov 17 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__SCROLLBARWIDGETBASE_H
#define INCLUDED__SCROLLBARWIDGETBASE_H

#include "widgetbase.h"
#include "resource.h"
#include "variant.h"

class ScrollBarWidgetBase: virtual public WidgetBase {
  public:
    ScrollBarWidgetBase(const char *name, int x, int y, int w, int h);
    virtual void SetBackgroundImage(ImageResource *image) = 0;
    virtual void SetBackgroundStyle(int style) = 0;
    virtual void SetKnobImage(ImageResource *image) = 0;
    virtual void SetKnobFocusImage(ImageResource *image) = 0;
    virtual void SetValue(int value) = 0;
    virtual void SetMaximum(int maximum) = 0;
    virtual void SetMinimum(int minimum) = 0;
    virtual void SetPageStep(int pagestep);
    virtual void SetReversed(bool reversed);
    virtual void Increment(void);
    virtual void Decrement(void);
    virtual void IncrementPage(void);
    virtual void DecrementPage(void);
    virtual void GotoStart(void);
    virtual void GotoEnd(void);
    virtual bool StandardAction(int actiontype);
  protected:
    int value;
    int minimum;
    int maximum;
    int pagestep;
    bool reversed;
    ImageResource *knob;
    ImageResource *knobfocus;
    ImageResource *background;
    int backgroundstyle;

    Variant pget_Background(void);
    int pset_Background(Variant value);
    Variant pget_BackgroundStyle(void);
    int pset_BackgroundStyle(Variant value);
    Variant pget_Knob(void);
    int pset_Knob(Variant value);
    Variant pget_KnobFocus(void);
    int pset_KnobFocus(Variant value);
    Variant pget_Value(void);
    int pset_Value(Variant value);
    Variant pget_Maximum(void);
    int pset_Maximum(Variant value);
    Variant pget_Minimum(void);
    int pset_Minimum(Variant value);
    Variant pget_PageStep(void);
    int pset_PageStep(Variant value);
    Variant pget_Reversed(void);
    int pset_Reversed(Variant value);
};

#endif
