/***************************************************************************
                          stringlist.h  -  generic string list class
                             -------------------
    begin                : Sat May 10 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__STRINGLIST_H
#define INCLUDED__STRINGLIST_H
 
#include <vector>

using namespace std;
 
class StringList {
  public:
    StringList(void);
    virtual ~StringList(void);
    const char *GetItem(int index);
    void SetItem(int index, const char *str);
    void Add(const char *str);
    void Insert(const char *str, int index);
    void Delete(int index);
    char *GetName(int index);
    const char *GetValue(int index);
    const char *GetValue(const char *name);
    void SetValue(int index, const char *value);
    void SetValue(const char *name, const char *value);
    int IndexOf(const char *item);
    int IndexOfName(const char *name);
    int size(void);
    const char *operator[](int i);
    void Clear(void);
    void SetDelimitedText(const char *delimitedtext, char delimiter);
  private:
    vector<char *> strings;
};

#endif
