/***************************************************************************
                          timerbase.h  -  base class for timers
                             -------------------
    begin                : Fri Nov 7 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__TIMERBASE_H
#define INCLUDED__TIMERBASE_H

#include "customobject.h"
#include "initialisebase.h"

class TimerObjectBase: public CustomObject, public InitialiseBase {
  public:
    TimerObjectBase(const char *name, int interval, bool autostart);
    virtual ~TimerObjectBase(void);
    void SetInterval(int interval);
    virtual void SetEnabled(bool enable);
    virtual void Fire(void);
    void AutoStart(void);
    int DoInitialise(void);
    void DoUninitialise(void);

  protected:
    int interval;
    bool enabled;
    bool autostart;

    Variant pget_Interval(void);
    int pset_Interval(Variant value);
    Variant pget_Enabled(void);
    int pset_Enabled(Variant value);

    Variant m_Start(int numargs, Variant args[]);
    Variant m_Stop(int numargs, Variant args[]);
};

#endif
