/***************************************************************************
         togglebuttonwidgetbase.h  -  togglebutton widget base class
                             -------------------
    begin                : Mon Nov 17 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__TOGGLEBUTTONWIDGETBASE_H
#define INCLUDED__TOGGLEBUTTONWIDGETBASE_H

#include "widgetbase.h"
#include "actionobject.h"
#include "resource.h"

class ToggleButtonWidgetBase: public virtual WidgetBase, public ActionObject {
  public:
    ToggleButtonWidgetBase(const char *name, int x, int y, int w, int h);
    virtual ~ToggleButtonWidgetBase(void);
    virtual void SetNormalImage(ImageResource *image) = 0;
    virtual void SetNormalFocusImage(ImageResource *image) = 0;
    virtual void SetCheckedImage(ImageResource *image) = 0;
    virtual void SetCheckedFocusImage(ImageResource *image) = 0;
    virtual void SetAction(std::string actionname);
    virtual void SetEnabled(bool enabled);
    virtual bool GetChecked(void);
    virtual void SetChecked(bool checked);
//X    void SimulateClick(void);
    void Execute(void);
  protected:
//X    char *caption;
    std::string action;
/*X    GUI_Label *captionlabel;
    FontEntry *font;
    SDL_Color *fontcolor;
    SDL_Color *fontfocuscolor;
    SDL_Color *fontdisabledcolor;
    SDL_Color *fontpressedcolor; */
    ImageResource *normalimage;
    ImageResource *normalfocusimage;
    ImageResource *checkedimage;
    ImageResource *checkedfocusimage;
//X    ImageResource *disabledimage;
/*X    int captionx;
    int captiony;
    int captiondropx;
    int captiondropy; */
    bool enabled;
    bool checked;
//X    void UpdateLabelColor(GUI_Widget *widget);
    virtual bool StandardAction(int actiontype);

    Variant pget_NormalImage(void);
    int pset_NormalImage(Variant value);
    Variant pget_NormalFocusImage(void);
    int pset_NormalFocusImage(Variant value);
    Variant pget_CheckedImage(void);
    int pset_CheckedImage(Variant value);
    Variant pget_CheckedFocusImage(void);
    int pset_CheckedFocusImage(Variant value);
    Variant pget_Enabled(void);
    int pset_Enabled(Variant value);
    Variant pget_Checked(void);
    int pset_Checked(Variant value);
    Variant pget_Action(void);
    int pset_Action(Variant value);
};


#endif
