/***************************************************************************
                          utils.h  -  header for utils.cpp
                             -------------------
    begin                : Thu Aug 15 2002
    copyright            : (C) 2002 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__UTILS_H
#define INCLUDED__UTILS_H

#include <vector>
#include <string>
#include <algorithm>

// Constants   FIXME: these should be moved elsewhere
#define IMAGESTYLE_NORMAL 0
#define IMAGESTYLE_TILED  1

#define AUTOPROPERTY_OFF   0
#define AUTOPROPERTY_ON    1
#define AUTOPROPERTY_AUTO  2

struct eboxy_color {
  unsigned char r;
  unsigned char g;
  unsigned char b;
};

// FIXME: functions in here should be documented
  
char *newstring(int length);
char *trimString(const char *string);
eboxy_color strtocolor(std::string colorstr);
std::string colortostr(eboxy_color color);
std::string getFilePath(std::string &filename);
std::string expandPath(std::string filename);
bool strtobool(const char *str);
int countstr(const char *str, char c);
int statfile(const char *filename);
bool isEmptyString(const char *str);
int stylestrtoint(const std::string &stylestr);
std::string styleinttostr(int style);
int autostrtoint(const std::string &autostr);
std::string autointtostr(int autovalue);
std::string lowercase(const std::string &str);
void delayms(unsigned int milliseconds);
int strtoint(const std::string &str);
bool checkFileExists(const char *filename);
bool checkRegExp(const char *str, const char *regex_str);

template <class T> int vectorFind(std::vector<T> v, T obj) {
  for(int i=0; i<v.size(); i++) {
    if(v[i] == obj)
      return i;
  }
  return -1;
};

#endif
