/***************************************************************************
                          conf.h  -  configuration definitions
                             -------------------
    begin                : Sat Nov 30 2002
    copyright            : (C) 2002 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__CONF_H
#define INCLUDED__CONF_H

#include <string>
   
#include "basewidgets/interfaceevent.h"

// Struct defs

const struct {
  const char *keystr;
  eboxykey key;
} keynamelist[] = {
  {"backspace", EKEY_BACKSPACE},
  {"tab", EKEY_TAB},
//  {"clear", EKEY_CLEAR
  {"enter", EKEY_RETURN},
  {"pause", EKEY_PAUSE},
  {"escape", EKEY_ESCAPE},
  {"space", EKEY_SPACE},
//EKEY_EXCLAIM
//EKEY_QUOTEDBL
//EKEY_HASH
//EKEY_DOLLAR
//EKEY_AMPERSAND
  {"quote", EKEY_QUOTE},
//EKEY_LEFTPAREN
//EKEY_RIGHTPAREN
//EKEY_ASTERISK},
//EKEY_PLUS
  {"comma", EKEY_COMMA},
  {"minus", EKEY_MINUS},
  {"dot", EKEY_DOT},
  {"slash", EKEY_SLASH},
  {"0", EKEY_0},
  {"1", EKEY_1},
  {"2", EKEY_2},
  {"3", EKEY_3},
  {"4", EKEY_4},
  {"5", EKEY_5},
  {"6", EKEY_6},
  {"7", EKEY_7},
  {"8", EKEY_8},
  {"9", EKEY_9},
  {"semicolon", EKEY_SEMICOLON},
//EKEY_LESS
  {"equals", EKEY_EQUALS},
//EKEY_GREATER
//EKEY_QUESTION
//EKEY_AT
  {"leftbracket", EKEY_LEFTBRACKET},
  {"backslash", EKEY_BACKSLASH},
  {"rightbracket", EKEY_RIGHTBRACKET},
// EKEY_CARET
// EKEY_UNDERSCORE
  {"backquote", EKEY_BACKQUOTE},
  {"a", EKEY_a},
  {"b", EKEY_b},
  {"c", EKEY_c},
  {"d", EKEY_d},
  {"e", EKEY_e},
  {"f", EKEY_f},
  {"g", EKEY_g},
  {"h", EKEY_h},
  {"i", EKEY_i},
  {"j", EKEY_j},
  {"k", EKEY_k},
  {"l", EKEY_l},
  {"m", EKEY_m},
  {"n", EKEY_n},
  {"o", EKEY_o},
  {"p", EKEY_p},
  {"q", EKEY_q},
  {"r", EKEY_r},
  {"s", EKEY_s},
  {"t", EKEY_t},
  {"u", EKEY_u},
  {"v", EKEY_v},
  {"w", EKEY_w},
  {"x", EKEY_x},
  {"y", EKEY_y},
  {"z", EKEY_z},
  {"delete", EKEY_DELETE},
  {"keypad0", EKEY_KP0},
  {"keypad1", EKEY_KP1},
  {"keypad2", EKEY_KP2},
  {"keypad3", EKEY_KP3},
  {"keypad4", EKEY_KP4},
  {"keypad5", EKEY_KP5},
  {"keypad6", EKEY_KP6},
  {"keypad7", EKEY_KP7},
  {"keypad8", EKEY_KP8},
  {"keypad9", EKEY_KP9},
  {"keypaddot", EKEY_KPDOT},
  {"keypadslash", EKEY_KPSLASH},
  {"keypadstar", EKEY_KPSTAR},
  {"keypadminus", EKEY_KPMINUS},
  {"keypadplus", EKEY_KPPLUS},
  {"keypadenter", EKEY_KPENTER},
  {"keypadequals", EKEY_KPEQUALS},
  {"uparrow", EKEY_UP},
  {"downarrow", EKEY_DOWN},
  {"rightarrow", EKEY_RIGHT},
  {"leftarrow", EKEY_LEFT},
  {"insert", EKEY_INSERT},
  {"home", EKEY_HOME},
  {"end", EKEY_END},
  {"pageup", EKEY_PAGEUP},
  {"pagedown", EKEY_PAGEDOWN},
  {"f1", EKEY_F1},
  {"f2", EKEY_F2},
  {"f3", EKEY_F3},
  {"f4", EKEY_F4},
  {"f5", EKEY_F5},
  {"f6", EKEY_F6},
  {"f7", EKEY_F7},
  {"f8", EKEY_F8},
  {"f9", EKEY_F9},
  {"f10", EKEY_F10},
  {"f11", EKEY_F11},
  {"f12", EKEY_F12},
  {"f13", EKEY_F13},
  {"f14", EKEY_F14},
  {"f15", EKEY_F15},
  {"numlock", EKEY_NUMLOCK},
  {"capslock", EKEY_CAPSLOCK},
  {"scrolllock", EKEY_SCROLLLOCK},
  {"rshift", EKEY_RSHIFT},
  {"lshift", EKEY_LSHIFT},
  {"rctrl", EKEY_RCTRL},
  {"lctrl", EKEY_LCTRL},
  {"ralt", EKEY_RALT},
  {"lalt", EKEY_LALT},
//  {"", EKEY_RMETA
//  {"", EKEY_LMETA
  {"lwin", EKEY_LSUPER},
  {"rwin", EKEY_RSUPER},
//  {"", EKEY_MODE
//  {"", EKEY_HELP
  {"printscreen", EKEY_PRINTSCREEN},
//  {"sysreq", EKEY_SYSREQ},
//  {"", EKEY_BREAK
  {"menu", EKEY_MENU},
//  {"", EKEY_POWER
  {"joystickbutton1",   EKEY_JOY_BUTTON_1},
  {"joystickbutton2",   EKEY_JOY_BUTTON_2},
  {"joystickbutton3",   EKEY_JOY_BUTTON_3},
  {"joystickbutton4",   EKEY_JOY_BUTTON_4},
  {"joystickbutton5",   EKEY_JOY_BUTTON_5},
  {"joystickbutton6",   EKEY_JOY_BUTTON_6},
  {"joystickbutton7",   EKEY_JOY_BUTTON_7},
  {"joystickbutton8",   EKEY_JOY_BUTTON_8},
  {"joystickbutton9",   EKEY_JOY_BUTTON_9},
  {"joystickup",        EKEY_JOY_UP},
  {"joystickdown",      EKEY_JOY_DOWN},
  {"joystickleft",      EKEY_JOY_LEFT},
  {"joystickright",     EKEY_JOY_RIGHT},
  {"joystickhatup",     EKEY_JOY_HAT_UP},
  {"joystickhatdown",   EKEY_JOY_HAT_DOWN},
  {"joystickhatleft",   EKEY_JOY_HAT_LEFT},
  {"joystickhatright",  EKEY_JOY_HAT_RIGHT},
  {NULL, EKEY_BACKSPACE} // doesn't matter what key you have here, NULL marks end of list
};

// Modifier key string to constant map
const struct {
  const char *modstr;
  int mod;
} modkeynamelist[] = {
  {"lshift",   MODKEY_LSHIFT},
  {"rshift",   MODKEY_RSHIFT},
  {"shift",    MODKEY_SHIFT},
  {"lctrl",    MODKEY_LCTRL},
  {"rctrl",    MODKEY_RCTRL},
  {"ctrl",     MODKEY_CTRL},
  {"lalt",     MODKEY_LALT},
  {"ralt",     MODKEY_RALT},
  {"alt",      MODKEY_ALT},
  // FIXME: Lock keys are ignored right now (difficult to handle)
//  {"numlock",  MODKEY_NUMLOCK},
//  {"capslock", MODKEY_CAPSLOCK},
//  {"anylock",  MODKEY_ANYLOCK},
  {"any",      MODKEY_ANY},
  {"none",     MODKEY_NONE},
  {NULL, MODKEY_NONE} // doesn't matter what key you have here, NULL marks end of list
};

struct keybinding {
  eboxykey key;
  int mod;
  char *action;
};

// Characters (other than alphanumerics) that can be entered into textfields
const struct {
  const char *charname;
  char charchr;
} textinputchars[] = {
  {"exclamation",  '!'},
  {"at",           '@'},
  {"hash",         '#'},
  {"dollar",       '$'},
  {"percent",      '%'},
  {"caret",        '^'},
  {"ampersand",    '&'},
  {"star",         '*'},
  {"openbracket",  '('},
  {"closebracket", ')'},
  {"underscore",   '_'},
  {"minus",        '-'},
  {"plus",         '+'},
  {"equals",       '='},
  {"opensquarebracket",  '['},
  {"closesquarebracket", ']'},
  {"openbrace",    '{'},
  {"closebrace",   '}'},
  {"pipe",         '|'},
  {"backslash",    '\\'},
  {"colon",        ':'},
  {"semicolon",    ';'},
  {"quote",        '\''},
  {"doublequote",  '\"'},
  {"slash",        '/'},
  {"question",     '?'},
  {"lessthan",     '<'},
  {"greaterthan",  '>'},
  {"comma",        ','},
  {"dot",          '.'},
  {"tilde",        '~'},
  {"backquote",    '`'},
  {"space",        ' '},
  {NULL,           '\0'}  // end of list
};

// Function Prototypes

int readKeyConf(void);
int writeKeyConf(std::string conffile);
void useDefaultBindings(void);

char textInputNameToChar(const char *charname);
const char *textInputCharToName(char c);
std::string keyToName(eboxykey key);
std::string modToName(int mod);

bool checkmodkeys(int pressedmod, int expectedmod);

int readConfFile(std::string &filename, std::map<std::string, std::string> &confmap, bool restricted);

#endif
