/***************************************************************************
                          constants.h  -  eboxy constants
                             -------------------
    begin                : Sat Aug 3 2002
    copyright            : (C) 2002 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__CONSTANTS_H
#define INCLUDED__CONSTANTS_H
 
#define STRINGIFY( arg ) #arg
#define XSTRINGIFY( arg ) STRINGIFY( arg )

// The application name as it is sent to LIRC
extern const char *LIRC_APP_NAME = "eboxy";

// The current version of eboxy
#define APP_MAJOR_VERSION 0
#define APP_MINOR_VERSION 4
#define APP_SUB_VERSION   1
extern const char *APP_VERSTRING = XSTRINGIFY(APP_MAJOR_VERSION) "." XSTRINGIFY(APP_MINOR_VERSION) "." XSTRINGIFY(APP_SUB_VERSION);

// This defines the oldest plugin client library that can work with this
// version of eboxy
extern const int PLUGIN_MIN_MAJOR_VERSION = 0;
extern const int PLUGIN_MIN_MINOR_VERSION = 4;
extern const int PLUGIN_MIN_SUB_VERSION = 0;

// Various defaults
extern const char *DTD_FILE = XSTRINGIFY(DATA_DIR) "eboxy.dtd";
extern const char *DEFAULT_XML_FILE = "eboxy.xml";
extern const int DEFAULT_FONTSIZE = 18;
extern const int DEFAULT_CAPTION_DROP_DELTA = 2;
extern const eboxy_color DEFAULT_FONT_COLOR = {0xFF, 0xFF, 0xFF};
extern const eboxy_color DEFAULT_SELECTED_FONT_COLOR = {0xFF, 0xFF, 0x0};

// Type strings
extern const char *TYPESTR_PAGE = "page";
extern const char *TYPESTR_LABEL = "label";
extern const char *TYPESTR_BUTTON = "button";
extern const char *TYPESTR_PICTURE = "picture";
extern const char *TYPESTR_LISTBOX = "listbox";
extern const char *TYPESTR_TEXTFIELD = "textfield";
extern const char *TYPESTR_SCROLLBAR = "scrollbar";
extern const char *TYPESTR_TOGGLEBUTTON = "togglebutton";
extern const char *TYPESTR_TIMER = "timer";
extern const char *TYPESTR_PLUGIN = "plugin";

#endif
