/***************************************************************************
                          errors.h - eboxy error constants
                             -------------------
    begin                : Sat Oct 5 2002
    copyright            : (C) 2002 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef INCLUDED__ERRORS_H
#define INCLUDED__ERRORS_H

 
#define EBERR_SUCCESS             0    /* No error occurred */

#define EBERR_FILE_ERROR          1    /* Some sort of file error (not found, access denied etc. */

#define EBERR_INVALID_PLUGIN_ID  16    /* Specified plugin ID is not valid */
#define EBERR_INVALID_NAME       17    /* Specified name is not a legal object name */
#define EBERR_OBJECT_NOT_FOUND   18    /* The named object doesn't exist */
#define EBERR_OBJECT_EXISTS      19    /* The named object already exists */
#define EBERR_MEMBER_EXISTS      20    /* The specified property/method already exists */
#define EBERR_NOT_OWNED          21    /* The object specified doesn't belong to you */
#define EBERR_INVALID_ARGS       22    /* numargs must be positive */
#define EBERR_EVENT_NOT_HANDLED  23    /* No event handler registered for specified event */
#define EBERR_OBJECT_IN_USE      24    /* The named object is currently being used */
#define EBERR_CREATE_FAILED      25    /* Object creation failed (usually unknown object type) */
#define EBERR_BAD_PROPERTY_VALUE 26    /* Specified property value is invalid */
#define EBERR_MEMBER_NOT_FOUND   27    /* The specified property/method doesn't exist */

#define EBERR_DLOPEN_FAILED      30    /* Couldn't dlopen specified library */
#define EBERR_VERSION_MISMATCH   31    /* Plugin was too old or too new for eboxy */
#define EBERR_MISSING_CLIENTLIB  32    /* Client library function not found */
#define EBERR_MISSING_FUNCTION   33    /* Required plugin function not found */
#define EBERR_PLUGIN_INIT_FAILED 34    /* Plugin's own initialisation failed */
#define EBERR_NORESOLVE          35    /* Function that should have resolved came back NULL */

#define EBERR_XML_NOT_VALID      40    /* The XML file did not validate against the DTD */
#define EBERR_DTD_PARSE_FAILED   41    /* The DTD could not be parsed */
#define EBERR_XML_PARSE_FAILED   42    /* XML parse failed (not well-formed, or other error) */
#define EBERR_XML_EMPTY          43    /* XML file is empty */
#define EBERR_XML_NOPAGES        44    /* XML file does not contain any <page> tags */
#define EBERR_XML_BAD            45    /* Other error with the contents of the XML file */

#define EBERR_ACTION_ASSIGNED    60    /* Action already assigned to something else */
#define EBERR_ACTION_INVALID     61    /* Not a valid user action name */


#endif
