/***************************************************************************
                          buttonwidget.h - eboxy button widget
                             -------------------
    begin                : Thu May 8 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__BUTTONWIDGET_H
#define INCLUDED__BUTTONWIDGET_H

#include <string>

#include "widget.h"
#include "../../basewidgets/buttonwidgetbase.h"

class ButtonWidget: public ebWidget, public ButtonWidgetBase {
  public:
    ButtonWidget(const char *name, int x, int y, int w, int h);
    virtual ~ButtonWidget(void);
    virtual GUI_Widget *Instantiate(void);
    virtual void Uninstantiate(void);
    void SetNormalImage(ImageResource *image);
    void SetSelectedImage(ImageResource *image);
    void SetPressedImage(ImageResource *image);
    void SetDisabledImage(ImageResource *image);
    void SetFont(FontResource *font);
    void SetFontColor(const eboxy_color &c);
    void SetFontFocusColor(const eboxy_color &c);
    void SetFontDisabledColor(const eboxy_color &c);
    void SetFontPressedColor(const eboxy_color &c);
    void SetCaption(std::string caption);
    void SetCaptionX(int value);
    void SetCaptionY(int value);
    void SetCaptionDropX(int value);
    void SetCaptionDropY(int value);
    void SetAction(std::string actionname);
    void SetEnabled(bool enabled);
    virtual void SetWidth(int value);
    virtual void SetHeight(int value);
    void SimulateClick(void);
    virtual void GotFocus(void);
    virtual void LostFocus(void);
    void Execute(void);

    virtual bool IsInstantiated(void);
    virtual bool IsGUIFocused(void);
    virtual bool IsEnabled(void);
  private:
    GUI_Label *captionlabel;
    void OnClick(GUI_Object *sender);
    void OnUpDown(GUI_Object *sender);
    void UpdateLabelColor(GUI_Widget *widget);
    void SetupCaptionLabel(GUI_Widget *rwidget);
};

#endif
