/***************************************************************************
               gui_resource.cpp  -  SDL_gui-based resource classes
                             -------------------
    begin                : Wed Oct 8 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "SDL_gui.h"

#include "gui_resource.h"
 
using namespace std;

SDL_guiImageResource::SDL_guiImageResource(string filename)
:ImageResource(filename) {
  
}

void *SDL_guiImageResource::Load(void) {
  if(!reshandle) {
    GUI_Surface *imgsurface = new GUI_Surface(filename.c_str());
    reshandle = imgsurface;
  }
  return reshandle;
}

void SDL_guiImageResource::Unload(void) {
  if(reshandle) {
    ((GUI_Surface *)reshandle)->DecRef();
    reshandle = NULL;
  }
}

SDL_guiFontResource::SDL_guiFontResource(string filename, int fontsize)
:FontResource(filename, fontsize) {

}

void *SDL_guiFontResource::Load(void) {
  if(!reshandle) {
    GUI_Font *font = new GUI_TrueTypeFont(filename.c_str(), fontsize);
    reshandle = font;
  }
  return reshandle;
}

void SDL_guiFontResource::Unload(void) {
  if(reshandle) {
    ((GUI_Font *)reshandle)->DecRef();
    reshandle = NULL;
  }
}
