/***************************************************************************
       gui_resourcemanager.h  -  manager for SDL_gui-based resources
                             -------------------
    begin                : Mon Oct 6 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__GUI_RESOURCEMANAGER_H
#define INCLUDED__GUI_RESOURCEMANAGER_H

#include <vector>
#include <string>

#include "../../basewidgets/resourcemanagerbase.h"

class ResourceManager: public ResourceManagerBase {
  public:
    virtual ~ResourceManager(void);
    void UnloadAllResources(void);
  protected:
    ImageResource *InternalLoadImageResource(std::string filename, bool force);
    FontResource *InternalLoadFontResource(std::string filename, int fontsize);
    std::vector<ImageResource *> images;
    std::vector<FontResource *> fonts;
};

#endif
