/***************************************************************************
                 gui_utils.cpp  -  SDL_gui extention utility functions
                             -------------------
    begin                : Tue Nov 19 2002
    copyright            : (C) 2002 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <cstring>
#include <cstdlib>

#include "SDL_gui.h"
#include "gui_extensions.h"
#include "../../errors.h"

using namespace std;

void DrawClipped(GUI_Surface *source, GUI_Drawable *dest, SDL_Rect destarea, int destx, int desty)
{
  SDL_Rect dr;
	SDL_Rect sr;
  			
	sr.w = dr.w = source->GetWidth();
	sr.h = dr.h = source->GetHeight();
	sr.x = sr.y = 0;
  			
	dr.x = destx;
	dr.y = desty;

	if (GUI_ClipRect(&sr, &dr, &destarea))
		dest->Draw(source, &sr, &dr);
}

unsigned int colortouint(SDL_Color c) {
  unsigned int cval = 0xFF000000;

  cval = cval | (c.r * 0x10000);
  cval = cval | (c.g * 0x100);
  cval = cval | (c.b);

  return cval;
}

// Find out if a point is inside a rectangle
bool pointinrect(int x, int y, SDL_Rect a) {
  return (x >= a.x && x <= (a.x + a.w) && y >= a.y && y <= (a.y + a.h));
}

// Find out if two SDL_Rects intersect
bool rectsintersect(SDL_Rect l, SDL_Rect r) {
  if(pointinrect(l.x, l.y, r) || pointinrect(l.x + l.w, l.y + l.h, r))
    return true;
  if(pointinrect(l.x, l.y + l.h, r) || pointinrect(l.x + l.w, l.y, r))
    return true;
  else if(l.x >= r.x && l.x <= (r.x + r.w) && r.y >= l.y && r.y <= (l.y + l.h))
    return true;
  else if(r.x >= l.x && r.x <= (l.x + l.w) && l.y >= r.y && l.y <= (r.y + r.h))
    return true;
  else
    return false;
}
