/***************************************************************************
                 labelwidget.h  -  eboxy static label widget
                             -------------------
    begin                : Tue May 13 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__LABELWIDGET_H
#define INCLUDED__LABELWIDGET_H

#include <string>

#include "../../basewidgets/labelwidgetbase.h"
#include "widget.h"
   
class LabelWidget: public ebWidget, public LabelWidgetBase {
  public:
    LabelWidget(const char *name, int x, int y, int w, int h, std::string text, FontResource *font);
    virtual ~LabelWidget(void);
    GUI_Widget *Instantiate(void);
    void SetText(std::string text);
    void SetFont(FontResource *font);
    void SetFontColor(eboxy_color c);
    void SetAutoSize(bool autosize);
    void SetAlign(enum_textalign align);
    void SetWordWrap(bool wordwrap);
  protected:
    void DrawText(char *str, SDL_Rect *sr, SDL_Rect *dr);

    virtual bool IsInstantiated(void);
    virtual bool IsGUIFocused(void);
    virtual bool IsEnabled(void);
};

int textaligntoalign(enum_textalign textalign);

#endif
