/***************************************************************************
                          listboxwidget.h  -  eboxy listbox widget
                             -------------------
    begin                : Tue May 13 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__LISTBOXWIDGET_H
#define INCLUDED__LISTBOXWIDGET_H

#include "widget.h"
#include "../../basewidgets/listboxwidgetbase.h"

class ListBoxWidget: public ebWidget, public ListBoxWidgetBase {
  public:
    ListBoxWidget(const char *name, int x, int y, int w, int h, FontResource *font, eboxy_color fontcolor);
    GUI_Widget *Instantiate(void);
    int Clone(ebWidget *newwidget);
    void SetFont(FontResource *font);
    void SetFontColor(eboxy_color c);
    void SetSelectedItemFontColor(eboxy_color c);
    void SetBackgroundImage(ImageResource *image);
    void SetBackgroundFocusImage(ImageResource *image);
    void SetBackgroundStyle(int style);
    void SetSelectedItemImage(ImageResource *image);
    void SetSelectedItemFocusImage(ImageResource *image);
    void SetSelectedItemStyle(int style);
    void SetScrollBarMode(int scrollbarmode);
    void SetScrollBarBackgroundImage(ImageResource *image);
    void SetScrollBarBackgroundStyle(int style);
    void SetScrollBarKnobImage(ImageResource *image);
    void SetScrollBarWidth(int width);
    void SetBorderX(int pixels);
    void SetBorderY(int pixels);
    void SetItemBorderX(int pixels);
    void SetItemBorderY(int pixels);
    void SetItemHeight(int pixels);
    void SetSelectedIndex(int index);
    int GetSelectedIndex(void);
    int GetItemCount(void);
    void SelectNext(int count);
    void SelectNextPage(void);
    void SelectPrevious(int count);
    void SelectPreviousPage(void);
    void AddItem(std::string text);
    void RemoveItem(int index);
    void Clear(void);
    void SetItemText(int index, std::string text);
    void ChooseSelection(void);
    void GotFocus(void);
    void LostFocus(void);

    virtual bool IsInstantiated(void);
    virtual bool IsGUIFocused(void);
    virtual bool IsEnabled(void);
  private:
    void OnChoose(GUI_Object *sender);
    void OnSelectionChange(GUI_Object *sender);
};

#endif
