/***************************************************************************
                          picturewidget.cpp  -  eboxy static image widget
                             -------------------
    begin                : Sat Aug 3 2002
    copyright            : (C) 2002 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <iostream>
#include <cstdlib>
#include "SDL_gui.h"

#include "picturewidget.h"

using namespace std;

PictureWidget::PictureWidget(const char *name, int x, int y, ImageResource *image)
: PictureWidgetBase(name, x, y, image), WidgetBase(x, y), Object(name) {
  
}

GUI_Widget *PictureWidget::Instantiate(void) {
  if(image) {
    GUI_Picture *pic = new GUI_Picture(name, x, y, w, h, (GUI_Surface *)(image->GetHandle()));
    realwidget = pic;
    realwidget->MarkChanged(); // for some strange reason this is required if you set image after construction
    return pic;
  }
  else {
    cerr << "PictureWidget::Instantiate - image property must be set" << endl;
    return NULL;
  }
}

void PictureWidget::SetImage(ImageResource *image) {
  this->image = image;
  GUI_Surface *surface = (GUI_Surface *)(image->GetHandle());
  SetWidth(surface->GetWidth());
  SetHeight(surface->GetHeight());
  if(realwidget) {
    ((GUI_Picture *)realwidget)->SetImage(surface);
    realwidget->MarkChanged();
  }
}

bool PictureWidget::IsInstantiated(void) {
  return (realwidget != NULL);
}

bool PictureWidget::IsGUIFocused(void) {
  return ebWidget::IsGUIFocused();
}

bool PictureWidget::IsEnabled(void) {
  return ebWidget::IsEnabled();
}
