/***************************************************************************
                          scrollbarwidget.h  -  eboxy scrollbar widget
                             -------------------
    begin                : Tue May 13 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__SCROLLBARWIDGET_H
#define INCLUDED__SCROLLBARWIDGET_H
 
#include "widget.h"
#include "../../basewidgets/scrollbarwidgetbase.h"

class ScrollBarWidget: public ebWidget, public ScrollBarWidgetBase {
  public:
    ScrollBarWidget(const char *name, int x, int y, int w, int h);
    virtual GUI_Widget *Instantiate(void);
    void SetBackgroundImage(ImageResource *image);
    void SetBackgroundStyle(int style);
    void SetKnobImage(ImageResource *image);
    void SetKnobFocusImage(ImageResource *image);
    void SetValue(int value);
    void SetMaximum(int maximum);
    void SetMinimum(int minimum);
    void SetPageStep(int pagestep);
    void SetReversed(bool reversed);
    virtual void GotFocus(void);
    virtual void LostFocus(void);

    virtual bool IsInstantiated(void);
    virtual bool IsGUIFocused(void);
    virtual bool IsEnabled(void);
  private:
    void OnChange(GUI_Object *sender);
};

#endif
