/***************************************************************************
                          textfieldwidget.h  -  eboxy textfield widget
                             -------------------
    begin                : Tue May 13 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__TEXTFIELDWIDGET_H
#define INCLUDED__TEXTFIELDWIDGET_H

#include <string>

#include "../../basewidgets/textfieldwidgetbase.h"
#include "widget.h"
   
class TextFieldWidget: public ebWidget, public TextFieldWidgetBase {
  public:
    TextFieldWidget(const char *name, int x, int y, int w, int h, FontResource *font, eboxy_color fontcolor, int maxlength);
    virtual ~TextFieldWidget(void);
    virtual GUI_Widget *Instantiate(void);
    void Uninstantiate(void);
    bool SendChar(char c, TextFieldInsertMode insmode);
    void Backspace(void);
    void DeleteCurrChar(void);
    void SetBackgroundImage(ImageResource *image);
    void SetBackgroundFocusImage(ImageResource *image);
    void SetBackgroundStyle(int style);
    void SetFont(FontResource *font);
    void SetFontColor(eboxy_color c);
    void SetBorderX(int pixels);
    void SetBorderY(int pixels);
    void SendEvent(SDL_Event e);
    void SetValidChars(std::string validchars);
    int GetCursorPos(void);
    void SetCursorPos(int pos);
    void SetText(std::string str);
    void GotFocus(void);
    void LostFocus(void);
  protected:
    void OnChange(GUI_Object *sender);

    virtual bool IsInstantiated(void);
    virtual bool IsGUIFocused(void);
    virtual bool IsEnabled(void);
};

#endif
