/***************************************************************************
                      timer.cpp - object wrapper for SDL timer
                             -------------------
    begin                : Tue Nov 5 2002
    copyright            : (C) 2002 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "SDL.h"

#include "timer.h"

using namespace std;

extern const char *TYPESTR_TIMER;

// Prototype of callback procedure
static Uint32 timer_callback(Uint32 interval, void *param);

TimerObject::TimerObject(const char *name, int interval, bool autostart)
: TimerObjectBase(name, interval, autostart), Object(name) {
}

TimerObject::~TimerObject(void) {
}

void TimerObject::SetEnabled(bool enable) {
  if(enable != this->enabled) {
    if(enable) {
      // Start timer
      this->timer_id = SDL_AddTimer(interval, &timer_callback, (void *)this);
    }
    else {
      // Stop timer
      SDL_RemoveTimer(timer_id);
    }
    this->enabled = enable;
  }
}

static Uint32 timer_callback(Uint32 interval, void *param) {
  ((TimerObject *)param)->Fire();
  return interval;
}

