/***************************************************************************
                       togglebuttonwidget.h  -  toggle button widget
                             -------------------
    begin                : Mon May 12 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__TOGGLEBUTTONWIDGET_H
#define INCLUDED__TOGGLEBUTTONWIDGET_H

#include "widget.h"
#include "../../basewidgets/togglebuttonwidgetbase.h"
   
class ToggleButtonWidget: public ebWidget, public ToggleButtonWidgetBase {
  public:
    ToggleButtonWidget(const char *name, int x, int y, int w, int h);
    virtual ~ToggleButtonWidget(void);
    virtual GUI_Widget *Instantiate(void);
    virtual void Uninstantiate(void);
    void SetWidth(int value);
    void SetHeight(int value);
    void SetNormalImage(ImageResource *image);
    void SetNormalFocusImage(ImageResource *image);
    void SetCheckedImage(ImageResource *image);
    void SetCheckedFocusImage(ImageResource *image);
    void SetEnabled(bool enabled);
    void SetChecked(bool checked);
    virtual void GotFocus(void);
    virtual void LostFocus(void);

    virtual bool IsInstantiated(void);
    virtual bool IsGUIFocused(void);
    virtual bool IsEnabled(void);
  private:
    void OnClick(GUI_Object *sender);
};

#endif
