/***************************************************************************
                          widget.h - eboxy widget class
                             -------------------
    begin                : Sun Dec 1 2002
    copyright            : (C) 2002 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__WIDGETS_H
#define INCLUDED__WIDGETS_H

#include "../../basewidgets/widgetbase.h"
#include "SDL_gui.h"

class ebWidget: virtual public WidgetBase {
  public:
    ebWidget(void);
    virtual ~ebWidget(void);
    virtual GUI_Widget *Instantiate(void) = 0;
    virtual void Uninstantiate(void);
    GUI_Widget *GetInstance(void);
    virtual void SetPosition(int x, int y);
    virtual int GetX(void);
    virtual int GetY(void);
    virtual int GetWidth(void);
    virtual int GetHeight(void);
    virtual SDL_Rect GetArea(void);
    void Invalidate(void);
    void InvalidateArea(void);
    virtual void GotFocus(void);
    virtual void LostFocus(void);
    virtual bool IsGUIFocused(void);
    virtual bool IsEnabled(void);
    virtual void SetVisible(bool visible);
  protected:
    GUI_Widget *realwidget;
};

#endif
