/***************************************************************************
                interfacemanager.h  -  interface plugin manager
                             -------------------
    begin                : Sun Jul 13 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__INTERFACEMANAGER_H
#define INCLUDED__INTERFACEMANAGER_H

#include <vector>

#include "basewidgets/interfaceplugin.h"
#include "basewidgets/pagebase.h"

// the types of the class factories
typedef InterfacePlugin *create_t();
typedef void destroy_t(InterfacePlugin *);

struct InterfacePluginRecord {
  void *handle;
  create_t *createfn;
  destroy_t *destroyfn;
  InterfacePlugin *plugin;
};

class InterfaceManager {
  public:
    InterfaceManager(void);
    virtual ~InterfaceManager(void);
    int LoadInterfacePlugin(const char *name);
    void UnloadInterfacePlugins(void);
    InterfacePlugin *GetPlugin(void);
    // Shortcut methods
    PageBase *GetLoadedPage(void);
    PageBase *FindPage(const char *name);
    int GetPageCount(void);
    PageBase *GetPage(int index);
    DynamicObject *FindExtPageObject(const char *name);
  private:
    InterfacePluginRecord ifplugin;
};

#endif
