/***************************************************************************
                          main.h  -  header for symbols in main.cpp
                             -------------------
    begin                : Thu May 22 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__MAIN_H
#define INCLUDED__MAIN_H

#include "basewidgets/dynamicobject.h"
#include "plugintypes.h"
#include "basewidgets/variant.h"
#include "basewidgets/pagebase.h"
#include "basewidgets/interfaceevent.h"
   
struct eboxyevent {
  int type;
  void *data1;
  void *data2;
};

// Functions defined in main.cpp
void SignalExit(void);
void SignalHide(void);
int switchPageEvent(const char *pagename);
int switchFileEvent(const char *filename, const char *pagename);
void nextWidgetEvent(void);
void prevWidgetEvent(void);
void acceptSelectionEvent(void);
Variant execute(const char *command, bool threaded, bool capture);
void executeHide(std::string command);
bool checkName(const char *name);
bool checkFileExists(const char *filename);
DynamicObject *findPageObject(const char *name, const char *type);
int checkVersion(eboxy_version_info verinfo, bool is_plugin);
int performAction(const char *action);
const char *getAppVersion(void);
PageBase *getLoadedPage(void);
void pushEvent(int type, void *data1, void *data2);

#endif
