/***************************************************************************
                          processobject.h  -  process wrapper
                             -------------------
    begin                : Thu May 22 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__PROCESSOBJECT_H
#define INCLUDED__PROCESSOBJECT_H

#include <pthread.h>

class Process {
  public:
    Process(const std::string &cmd);
    virtual ~Process(void);
    int Execute(void);
    int ExecuteThreaded(void);
    bool IsDone(void);
    int GetReturnCode(void);
    void SetCapture(bool capture);
    std::string GetOutput(void);
  private:
    std::string cmd;
    pthread_t exec_thread;
    bool capture;
    bool done;
    int returncode;
    std::string output;
};

#define EXEC_PIPE_BUFFERSIZE 256

#endif
