/***************************************************************************
                  resolver.cpp  -  eboxy name-to-object resolver
                             -------------------
    begin                : Thu Nov 20 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <iostream>
 
#include "resolver.h"
#include "pluginmanager.h"
#include "main.h"
 
using namespace std;

extern PluginManager plugin_manager;

DynamicObject *Resolver::Resolve(const char *name, int scope) {
  switch(scope) {
    case RSCOPE_TEMP:
      return plugin_manager.FindTempWidget(name);
    case RSCOPE_PAGE:
      return findPageObject(name, NULL); // FIXME
    case RSCOPE_GLOBAL:
      return plugin_manager.FindObject(name);
    default:
      cerr << "Resolver: unrecognised scope " << scope << endl;
      return NULL;
  }
}
