/***************************************************************************
                scriptobject.cpp  -  eboxy script handling object
                             -------------------
    begin                : Sun Aug 4 2002
    copyright            : (C) 2002 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <iostream>
#include <cstdlib>
#include <cstring>

#include "basewidgets/utils.h"
#include "script.h"
#include "scriptobject.h"

using namespace std;

// Variable defined in main.cpp
extern string xmlFile;

// Function defined by the Bison-generated parser
void yyparse(void *parm);

Script::Script(const char *name, const char *code, int flags)
: ScriptBase(name, code) {
  this->flags = flags;
}

Script::~Script(void) {
}

int Script::Run(void) {
  // We need to use the reference count here so that the script object doesn't get freed
  // until it has finished executing
  IncRef();
  // Thanks for the reentrant parser go to Pavel Kalugin, who in 1998
  // posted to comp.compilers explaining how to munge a C++ Flex lexer together
  // with a Bison parser - and it works :)
  ScriptLexer *lexer = new ScriptLexer(code, flags);
  lexer->SetLineOffset(lineoffset);
  lexer->SetFileName(xmlFile.c_str());
  ParserExecutionContext *parser_context = new ParserExecutionContext(lexer);
  yyparse((void *)parser_context);
  delete parser_context;
  delete lexer;
  DecRef();
  return 0;  // FIXME: return other values?
}

