/***************************************************************************
                          systemobject.h  -  global system object
                             -------------------
    begin                : Wed May 14 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__SYSTEMOBJECT_H
#define INCLUDED__SYSTEMOBJECT_H

#include "basewidgets/customobject.h"
#include "basewidgets/objcontainer.h"
#include "basewidgets/timerbase.h"

class SystemObject: public CustomObject, public ObjectContainer {
  public:
    SystemObject(void);
    ~SystemObject(void);
    int FireSystemEvent(const char *event);
    void AutoStartTimers(void);
    void InitialisePlugins(void);
  private:
    vector<TimerObjectBase *> timers;

    Variant pget_ScreenWidth(void);
    Variant pget_ScreenHeight(void);
    Variant pget_CurrentFile(void);
    Variant pget_Version(void);
    Variant pget_PageCount(void);

    Variant m_Quit(int numargs, Variant args[]);
    Variant m_FocusNext(int numargs, Variant args[]);
    Variant m_FocusPrevious(int numargs, Variant args[]);
    Variant m_SelectFocused(int numargs, Variant args[]);
    Variant m_PrintPluginList(int numargs, Variant args[]);
    Variant m_PerformAction(int numargs, Variant args[]);
    Variant m_GetPage(int numargs, Variant args[]);
    Variant m_GotoPage(int numargs, Variant args[]);
};

#endif
