/***************************************************************************
                          types.h  -  eboxy typedefs/structs
                             -------------------
    begin                : Thu May 22 2003
    copyright            : (C) 2003 by Paul Eggleton
    email                : bluelightning@bluelightning.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef INCLUDED__TYPES_H
#define INCLUDED__TYPES_H

#include "SDL.h"
#include "SDL_gui.h"
 
class ebCustomObject;
 
// These types are used for the new dynamic property system
typedef const char *(*propertygetfn)(ebCustomObject *source);
typedef void (*propertysetfn)(ebCustomObject *source, const char *value);
typedef const char *(*methodfn)(ebCustomObject *, const char *, int, const char *[]);

class Script;

struct EventTemplate {
  char *type;
  bool threaded;
  Script *script;
  char *sourceobject;
};


// FIXME: should these be elsewhere?
struct ImageEntry {
	char *filename;
	GUI_Surface *surface;
};

struct FontEntry {
	char *filename;
  int size;
	GUI_Font *font;
};

#endif
